function Draw3D()
  -- 3D Drawing Start
  Gu.start3d()

  -- clear screen
  Gu.clearDepth(0)
  Gu.clear(Gu.COLOR_BUFFER_BIT|Gu.DEPTH_BUFFER_BIT)

  -- setup projection and view matrices

  Gum.matrixMode(Gu.PROJECTION)
  Gum.loadIdentity()
  Gum.perspective(50, 16/9, 1, 1000)

  Gum.matrixMode(Gu.VIEW)
  Gum.loadIdentity()

--CUBE-------------------------------------------------------------------------------
  if show.cube=="on" then
    -- setup matrix for cube
    Gum.matrixMode(Gu.MODEL)
    Gum.loadIdentity()
    Gum.translate(trans.x, trans.y, trans.z)
    Gum.rotateXYZ(rot.x*(Gu.PI/180),rot.y*(Gu.PI/180),rot.z*(Gu.PI/180))

    -- draw cube without texture
    Gu.disable(Gu.TEXTURE_2D)
    Gum.drawArray(Gu.TRIANGLES, Gu.COLOR_8888|Gu.VERTEX_32BITF|Gu.TRANSFORM_3D, cube)
  end

--CUBE WIREFRAME---------------------------------------------------------------------
  if show.wire=="Squares" or show.wire=="Triangles" then
    -- setup matrix for wireframe
    Gum.matrixMode(Gu.MODEL)
    Gum.loadIdentity()
    Gum.translate(trans.x, trans.y, trans.z)
    Gum.rotateXYZ(rot.x*(Gu.PI/180),rot.y*(Gu.PI/180),rot.z*(Gu.PI/180))

    -- draw wireframe without texture
    Gu.disable(Gu.TEXTURE_2D)
    Gum.drawArray(Gu.LINES, Gu.COLOR_8888|Gu.VERTEX_32BITF|Gu.TRANSFORM_3D, cube_wireframe[show.wirelvl])
  end

--END POINTS--------------------------------------------------------------------------
  if show.endp=="on" then
    -- setup matrix for end points
    Gum.matrixMode(Gu.MODEL)
    Gum.loadIdentity()
    Gum.translate(trans.x, trans.y, trans.z)
    Gum.rotateXYZ(rot.x*(Gu.PI/180),rot.y*(Gu.PI/180),rot.z*(Gu.PI/180))

    -- draw end points without texture
    Gu.disable(Gu.TEXTURE_2D)
    Gum.drawArray(Gu.POINTS, Gu.COLOR_8888|Gu.VERTEX_32BITF|Gu.TRANSFORM_3D, end_points)
  end

--EDGE POINTS------------------------------------------------------------------------
  if show.edgep=="on" then
    -- setup matrix for edge points
    Gum.matrixMode(Gu.MODEL)
    Gum.loadIdentity()
    Gum.translate(trans.x, trans.y, trans.z)
    Gum.rotateXYZ(rot.x*(Gu.PI/180),rot.y*(Gu.PI/180),rot.z*(Gu.PI/180))

    -- draw edge points without texture
    Gu.disable(Gu.TEXTURE_2D)
    Gum.drawArray(Gu.POINTS, Gu.COLOR_8888|Gu.VERTEX_32BITF|Gu.TRANSFORM_3D, edge_points)
  end

--FACE POINTS------------------------------------------------------------------------
  if show.facep=="on" then
    -- setup matrix for face points
    Gum.matrixMode(Gu.MODEL)
    Gum.loadIdentity()
    Gum.translate(trans.x, trans.y, trans.z)
    Gum.rotateXYZ(rot.x*(Gu.PI/180),rot.y*(Gu.PI/180),rot.z*(Gu.PI/180))

    -- draw face points without texture
    Gu.disable(Gu.TEXTURE_2D)
    Gum.drawArray(Gu.POINTS, Gu.COLOR_8888|Gu.VERTEX_32BITF|Gu.TRANSFORM_3D, face_points)
  end

--AXIS-------------------------------------------------------------------------------
  if show.axis=="on" then
    -- setup matrix for axis
    Gum.matrixMode(Gu.MODEL)
    Gum.loadIdentity()
    Gum.translate(trans.x, trans.y, trans.z)
    Gum.rotateXYZ(rot.x*(Gu.PI/180),rot.y*(Gu.PI/180),rot.z*(Gu.PI/180))

    -- draw axis without texture
    Gu.disable(Gu.TEXTURE_2D)
    Gum.drawArray(Gu.LINES, Gu.COLOR_8888|Gu.VERTEX_32BITF|Gu.TRANSFORM_3D, axis)
  end

  -- 3D Drawing End
  Gu.end3d()
  
  if show.misc=="on" then
    --screen:print(x,y,txt,col.txt)
    screen:print(1,1,"Rotation X="..rot.x,col.txt)
    screen:print(1,9,"Rotation Y="..rot.y,col.txt)
    screen:print(1,17,"Rotation Z="..rot.z,col.txt)
    screen:print(1,25,"Translation Z="..trans.z,col.txt)
  end

  screen.waitVblankStart()
  screen.flip()
  screen:clear(col.clear)
end

function Menu()
  local menupos=0
  while true do
    --screen:print(x,y,txt,col.txt)
    screen:print(8,8,"Show:",col.txt)
    screen:print(16,16,"Solid=" .. show.cube,col.txt)
    screen:print(16,24,"Wireframe=" .. show.wire,col.txt)
    screen:print(16,32,"Points:",col.txt)
    screen:print(24,40,"End Points=" .. show.endp,col.txt)
    screen:print(24,48,"Edge Points=" .. show.edgep,col.txt)
    screen:print(24,56,"Face Points=" .. show.facep,col.txt)
    screen:print(16,64,"Axis=" .. show.axis,col.txt)
    screen:print(16,72,"Misc=" .. show.misc,col.txt)
    screen:print(8,80,"EXIT MENU",col.txt)
    screen:print(8,88,"QUIT PROGRAM",col.txt)

    if menupos==0 then
      screen:print(8,16,">Solid=" .. show.cube,col.txtsel)
    elseif menupos==1 then
      screen:print(8,24,">Wireframe=" .. show.wire,col.txtsel)
    elseif menupos==2 then
      screen:print(16,40,">End Points=" .. show.endp,col.txtsel)
    elseif menupos==3 then
      screen:print(16,48,">Edge Points=" .. show.edgep,col.txtsel)
    elseif menupos==4 then
      screen:print(16,56,">Face Points=" .. show.facep,col.txtsel)
    elseif menupos==5 then
      screen:print(8,64,">Axis=" .. show.axis,col.txtsel)
    elseif menupos==6 then
      screen:print(8,72,">Misc=" .. show.misc,col.txtsel)
    elseif menupos==7 then
      screen:print(0,80,">EXIT MENU",col.txtsel)
    elseif menupos==8 then
      screen:print(0,88,">QUIT PROGRAM",col.txtsel)
    end

    if UP1() then
      menupos=menupos-1
    elseif DOWN1() then
      menupos=menupos+1
    end

    if CROSS1() then
      if menupos==0 then
        if show.cube=="on" then
          show.cube="off"
        else
          show.cube="on"
        end
      elseif menupos==1 then
        if show.wire=="Squares" then
          show.wire="Triangles"
          show.wirelvl=2
        elseif show.wire=="Triangles" then
          show.wire="off"
          show.wirelvl=1
        elseif show.wire=="off" then
          show.wire="Squares"
          show.wirelvl=1
        end
      elseif menupos==2 then
        if show.endp=="on" then
          show.endp="off"
        else
          show.endp="on"
        end
      elseif menupos==3 then
        if show.edgep=="on" then
          show.edgep="off"
        else
          show.edgep="on"
        end
      elseif menupos==4 then
        if show.facep=="on" then
          show.facep="off"
        else
          show.facep="on"
        end
      elseif menupos==5 then
        if show.axis=="on" then
          show.axis="off"
        else
          show.axis="on"
        end
      elseif menupos==6 then
        if show.misc=="on" then
          show.misc="off"
        else
          show.misc="on"
        end
      elseif menupos==7 then
        return "EXIT"
      elseif menupos==8 then
        return "QUIT"
      end
    elseif CIRCLE1() or START1() then
      return "EXIT"
    end

    if menupos<0 then
      menupos=8
    elseif menupos>8 then
      menupos=0
    end

    screen.waitVblankStart()
    screen.flip()
    screen:clear(col.clear)
  end
end

function Controls3D()
  AnalogY=Controls.read():analogY()
  AnalogX=Controls.read():analogX()

  if UP() then
    rot.x=rot.x-1
  end
  if DOWN() then
    rot.x=rot.x+1
  end

  if LEFT() then
    rot.y=rot.y-1
  end
  if RIGHT() then
    rot.y=rot.y+1
  end

  if LTRIG() then
    rot.z=rot.z-1
  end
  if RTRIG() then
    rot.z=rot.z+1
  end
  if TRIANGLE1() then
    trans.z=trans.z+1
  end
  if CROSS1() then
    trans.z=trans.z-1
  end

--Stick Y Pos------------------------------------------------------------------------
  if AnalogY>=20 and AnalogY<99 then
    rot.x=rot.x+3
  end
  if AnalogY>=99 and AnalogY<=127 then
    rot.x=rot.x+6
  end

--Stick Y Neg------------------------------------------------------------------------
  if AnalogY<=-21 and AnalogY>-100 then
    rot.x=rot.x-3
  end
  if AnalogY<=-100 and AnalogY>=-128 then
    rot.x=rot.x-6
  end

--Stick X Pos------------------------------------------------------------------------
  if AnalogX>=20 and AnalogX<99 then
    rot.y=rot.y+3
  end
  if AnalogX>=99 and AnalogX<=127 then
    rot.y=rot.y+6
  end

--Stick X Neg------------------------------------------------------------------------
  if AnalogX<=-21 and AnalogX>-100 then
    rot.y=rot.y-3
  end
  if AnalogX<=-100 and AnalogX>=-128 then
    rot.y=rot.y-6
  end
end

function Rotation_Check()
 if rot.x>=360 then
     rot.x=0
  end
  if rot.x<=-1 then
     rot.x=359
  end
  if rot.y>=360 then
     rot.y=0
  end
  if rot.y<=-1 then
     rot.y=359
  end
  if rot.z>=360 then
     rot.z=0
  end
  if rot.z<=-1 then
     rot.z=359
  end
end